# Tor proposals by status

{warning}

<!-- If you want to make changes here, make sure to edit the -->
<!-- README_template.md file.  The README.md file is generated by the -->
<!-- reindex.py script. -->

Here we have a set of proposals for changes to the Tor protocol.  Some
of these proposals are implemented; some are works in progress; and some
will never be implemented.

Below are a list of proposals sorted by status.  See
[INDEX.md](/proposals/INDEX.md) for a list of proposals sorted by number.

# Active proposals by status

## OPEN proposals: under discussion

These are proposals that we think are likely to be complete, and ripe
for discussion.

{OPEN}

## ACCEPTED proposals: slated for implementation

These are the proposals that we agree we'd like to implement.  They
might or might not have a specific timeframe planned for their
implementation.

{ACCEPTED}

## FINISHED proposals: implemented, specs not merged

These proposals are implemented in some version of Tor; the proposals
themselves still need to be merged into the specifications proper.

{FINISHED}

## META proposals: about the proposal process

These proposals describe ongoing policies and changes to the proposals
process.

{META}

## INFORMATIONAL proposals: not actually specifications

These proposals describe a process or project, but aren't actually
proposed changes in the Tor specifications.

{INFORMATIONAL}

# Preliminary proposals

## DRAFT proposals: incomplete works

These proposals have been marked as a draft by their author or the editors,
indicating that they aren't yet in a complete form.  They're still open for
discussion.

{DRAFT}

## NEEDS-REVISION proposals: ideas that we can't implement as-is

These proposals have some promise, but we can't implement them without
certain changes.

{NEEDS-REVISION}

## NEEDS-RESEARCH proposals: blocking on research

These proposals are interesting ideas, but there's more research that would
need to happen before we can know whether to implement them or not, or to
fill in certain details.

{NEEDS-RESEARCH}

# Inactive proposals by status

## CLOSED proposals: implemented and specified

These proposals have been implemented in some version of Tor, and the
changes from the proposals have been merged into the specifications as
necessary.

{CLOSED}

## RESERVE proposals: saving for later

These proposals aren't anything we plan to implement soon, but for one
reason or another we think they might be a good idea in the
future. We're keeping them around as a reference in case we someday
confront the problems that they try to solve.

{RESERVE}

## SUPERSEDED proposals: replaced by something else

These proposals were obsoleted by a later proposal before they were
implemented.

{SUPERSEDED}

## DEAD, REJECTED, OBSOLETE proposals: not in our plans

These proposals are not on-track for discussion or
implementation. Either discussion has stalled out (the proposal is
DEAD), the proposal has been considered and not adopted (the proposal is
REJECTED), or the proposal addresses an issue or a solution that is no
longer relevant (the proposal is OBSOLETE).

{DEAD_REJECTED_OBSOLETE}



